Imports System.Xml

Class MBSA
    Function doit(ByVal f As String, ByVal dt As DataTable) As Integer
        Dim xtr As XmlTextReader
        Dim PC, IP, VName, VDesc As String
        Dim Grade As Integer
        Dim ScanDate As Date
        Dim dr As DataRow
        Dim rec_count As Integer

        xtr = New XmlTextReader(f)

        ' Parse the file and display each of the nodes.
        PC = ""
        IP = ""
        VName = ""
        VDesc = ""
        While xtr.Read()
            Select Case xtr.NodeType
                Case XmlNodeType.Element
                    Select Case xtr.Name
                        Case "SecScan"
                            PC = xtr.GetAttribute("Machine")
                            IP = xtr.GetAttribute("IP")
                            ScanDate = CDate(xtr.GetAttribute("Date"))
                        Case "Check"
                            Grade = CInt(xtr.GetAttribute("Grade"))
                            VName = xtr.GetAttribute("Name")
                        Case "Advice"
                            VDesc = xtr.ReadString
                            Try
                                dr = dt.NewRow
                                dr("PC") = PC
                                dr("IP") = IP
                                dr("ScanDate") = ScanDate
                                dr("Grade") = Grade
                                dr("VName") = Left(VName, 150)
                                dr("VDesc") = Left(VDesc, 255)
                                dt.Rows.Add(dr)
                                rec_count += 1
                            Catch ex As Exception
                                MsgBox("Couldn't add new record" & vbCr & ex.Message, MsgBoxStyle.Exclamation, "Darn!")
                            End Try
                    End Select
            End Select
        End While

        xtr.Close()
        Return rec_count
    End Function
End Class
